<?php

namespace App\Http\Controllers;
use App\Product;
use App\role_user;
use Illuminate\Http\Request;
use App\Role;
use App\User;
use App\EbKey;
use App\EbRequest;
use App\Setting;
use App\Http\Requests;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;
use Tymon\JWTAuth\Facades\JWTAuth;
use Carbon\Carbon;
use Illuminate\Support\Facades\Log;

class AuthenticateController extends Controller
{
    public function authenticate(Request $request)
    {
       // return response()->json(['error' => 'Down for maintenance!'], 401);
        //exit;
	    $permissions = array();
		if(!$request->has("key")){
			return response()->json(['error' => 'Invalid Credentials'], 401);
		}
		$tempcode = $request->input("key");
		$user = User::where('tempcode', $tempcode)->first(["id", "shopurl", "status", "tempcode", "membershiptype", "plan", "sync", "skulimit", "skuconsumed", "review", "custommode", "created_at", "paid_at", "usermsg"]);		
		if(!$user){
			return response()->json(['error' => 'Invalid Credentials'], 401);
		}

		$products =Product::where('user_id', '=',$user->id)->count();
		$vproducts = Product::where('user_id', '=',$user->id)->where('status', '=', 'Imported')->count();
		$ebayrequeststatus = EbRequest::where('user_id', '=',$user->id)->count();
		Log::info(json_encode($products));


		$user->lastlogin = DB::raw('now()');
        $user->save();
		$paid_at = $user->paid_at;
		$created_at = $user->created_at;
		$review = $user->review;
		$fromtime = new Carbon($paid_at);
		if(strtotime($paid_at) < 1){
			$fromtime = new Carbon($created_at);
		}		
		$now = Carbon::now();
		$difference = $fromtime->diffInDays($now);
		//Log::info("difference == ".$difference);
		if($difference > 30 && $user->sync == 0 && $user->review == 0) {
			$user->expired = 1;
		} else if($difference > 60 && $user->sync == 0 && $user->review == 1) {
			$user->expired = 1;
		} else {
			$user->expired = 0;
		}
		$user->expired = 0;
		$ebKey = $user->ebKey()->first();
		if(!$ebKey){
			$user->ebtoken = 0;
		} else {
		    $expirydate = $ebKey->expirydate;
		    $expirytime = new Carbon($expirydate);
		    $expdifference = $now->diffInDays($expirytime, false);
			if($ebKey->valid == 0 || $expdifference < 15){
				$user->ebtoken = 2;
			} else {
				$user->ebtoken = 1;
			}
		}
		$planprice = 0.2;
		if($user->plan == 1){
			$planprice = 0.08;
		} else if($user->plan == 2){
			$planprice = 0.05;
		} else if($user->plan == 3){
			$planprice = 0.03;
		}
		$user->planprice = $planprice;
		$user->ebproduct = $products;
		$user->importedproducts =$vproducts;
		$user->showpop=0;
		$user->ebrequest = $ebayrequeststatus;
		if($user->usermsg == 'shtoeb'){
			$user->showpop=1;
		}
   

		$settings = $user->settings()->first();

		if (!$settings) {
			$settingObj = new Setting;
			$settingObj->published = 1;
			$settingObj->tags = "";
			$settingObj->vendor = "";
			$settingObj->product_type = "";
			$settingObj->inventory_policy = "shopify";
			$settingObj->inventory_sync = 0;
			$settingObj->price_sync = 0;
			$settingObj->outofstock_action = "outofstock";
			$settingObj->desc_cond = 0;
			$settingObj->desc_itemspecs = 0;
			$settingObj->markupenabled = 0;
			$settingObj->markuptype = 'FIXED';
			$settingObj->markupval = 0;
			$settingObj->markupround = 0;
			$user->settings()->save($settingObj);

		}



		try {
            // verify the credentials and create a token for the user
            if (! $token = JWTAuth::fromUser($user)) {
                return response()->json(['error' => 'Invalid Credentials'], 401);
            }
        } catch (JWTException $e) {
            // something went wrong
            return response()->json(['error' => 'could_not_create_token'], 500);
        }    
        return response()->json(compact('token','user')); 
    }
}