<?php

Route::group(['prefix' => 'v1'], function()
{
	// authentication
    Route::resource('authenticate', 'AuthenticateController', ['only' => ['index']]);
    Route::post('authenticate', 'AuthenticateController@authenticate');
    
	Route::resource('product', 'ProductController', ['only' => ['index']]);
    Route::get('product/search','ProductController@search');    
	Route::post('product/block/{id}', 'ProductController@block'); 
	Route::post('product/unblock/{id}', 'ProductController@unblock'); 
	Route::post('product/push/{id}', 'ProductController@push');
	Route::post('product/pushall', 'ProductController@pushall');
	Route::get('product/suggestedplan', 'ProductController@suggestedPlan');
	Route::get('product/variants', 'ProductController@getVariants');
	Route::post('product/updatepdesc', 'ProductController@updatePDesc');
	Route::post('product/reimport/{id}', 'ProductController@reimport');
	Route::post('product/remove/{id}', 'ProductController@remove');
	Route::get('product/export/file', 'ProductController@exportFile');
//chnages 
	Route::post('product/pushallreadytoimport', 'ProductController@pushAllReadyToImport');
	Route::post('product/deleteallimportedfromdb', 'ProductController@deleteAllImportedFromDB');
	Route::post('product/fetchall', 'ProductController@fetchAllScheduledListings');
	Route::get('product/nextpage','ProductController@nextpage');

	//end here 
	
	Route::get('product/shopifytoebay', 'ProductController@ShopifyToEbay');

	Route::get('ebconfig','EbConfigController@index');
	Route::post('ebconfig/fetch','EbConfigController@fetch');
	Route::get('ebconfig/status','EbConfigController@status');
	
	Route::get('settings','SettingsController@index');
	Route::post('settings','SettingsController@store');
	Route::post('settings/pricingrules','SettingsController@savePricingRulesSettings');
	Route::post('settings/sync','SettingsController@saveSyncSettings');
	
	Route::post('contact/requestquote','ContactController@requestquote');
});